// From Nano for Addd & xm__
// at 2011-05-15
// http://forum.rudtp.ru/showthread.php?t=44172

// path2guides.jsx
// The Adobe Photoshop javascript

// This script create new guides of current document
// for every horisontal or vertical lines of path

// Save the current preferences 
var startRulerUnits = app.preferences.rulerUnits;

// Set Photoshop to use pixels
app.preferences.rulerUnits = Units.PIXELS;


var 
    guides = app.activeDocument.guides,
    pathItems = app.activeDocument.pathItems,
    counter = 0;

// browse all path in document
for (var i = pathItems.length; i--;) {
    var pathItem = pathItems[i];
    
    // seek lines
    for (var j = pathItem.subPathItems.length; j--;) {
        var subPath = pathItem.subPathItems[j];
        
        // used subPaths containing only two points
        if (subPath.pathPoints.length != 2) continue;
        
        var
            anchor0 = subPath.pathPoints[0].anchor,
            anchor1 = subPath.pathPoints[1].anchor;
        
        if (anchor0[0] == anchor1[0]) { // vertical line
            guides.add(
                Direction.VERTICAL,
                anchor0[0]
            );
            counter++;
        } else if (anchor0[1] == anchor1[1]) { // horisontal line
            guides.add(
                Direction.HORIZONTAL,
                anchor0[1]
            );
            counter++;
        }
    }
}
// Reset the application preferences
app.preferences.rulerUnits = startRulerUnits;

alert(counter + ' guides added');
